<?php
class Articulo { // clase Articulo
// explicacin captulo 27
 
	private $_aLista=array();
	private $_bDirty=False;
	
	/*
    * Mtodos
    * Articulo($sArticuloID) // Constructor
    * leerArticulo($sArticuloID) 
    * aadirArticulo(...)
    * modificarArticulo
    * eliminarArticulo 
    * tieneReferencias
    */   

 
function Articulo($sArticuloID=""){

          
	// Lectura de Articulo
	if ( $sArticuloID <> "")  $this->_aLista['ArticuloID']=$sArticuloID;
          
}  // fin constructor

function __get($nv){
		 
	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) )  
		return $this->_aLista[$nv];
	else 
	return False;
  
}  // fin funcin _get
	 
function __set($nv,$val){
		 
	$this->_aLista[$nv] = $val;
	$this->_bDirty = True;
	return True;
		
} // fin funcin _set
	
function leerArticulo(){
         
	// Rutina de lectura de un  Articulo
	$sql = "SELECT * FROM Articulos
                 WHERE ArticuloID = '" . $this->ArticuloID."'";

	$rst = accederMySQL($sql);
	$this->_aLista = $rst->fetch_assoc();
	$rst->free();
	return $this->_aLista;
         
   	 
} // fin LeerArticulo

function aadirArticulo(){
          
	if (!$this->_bDirty) return;
	$sql="SELECT Secuencia FROM Articulos 
            WHERE 
            ArticuloID = \"".$this->RefArticuloID."\";";

	// crea el conjunto de resultados
	$rst = accederMySQL($sql);
	$row = $rst->fetch_row();
	
	// la secuencia sirve para obtener rpidamente
	// el rbol de artculos de un tema
	//
	// la secuencia de un artculo est compuesta 
	// por un nmero formado por:
	// nnnnnnmmmmmm
	// siendo 
	// nnnnnn el nmero de tema
	// mmmmmm el nmero del artculo
	//  
	// Si es una respuesta a un artculo
	// nnnnnn es el nmero de secuencia del artculo al que responde
	// (en este caso, la longitud de este nmero es variable
	// segn la cantidad de niveles del artculo, ya que cada
	// nro. tiene 6 dgitos)
	// mmmmmm el nmero del artculo
	
	if (!$row) 
		$sSecuencia = trim(fijo($this->TemaID));
	else 
      	$sSecuencia = $row[0] ;

      
	$this->FechaCreacion = date("Y-m-d H:i:s");
	$sql ="INSERT INTO Articulos(TemaID, ";
	$sql.=   "RefArticuloID, Titulo, Texto, Usuario, Revisado, FechaCreacion) ";
	$sql.=   "VALUES (\"";
	$sql.=    $this->TemaID."\",\"";
	$sql.=    $this->RefArticuloID."\",\"";
	$sql.=    $this->Titulo."\",\"";
	$sql.=    $this->Texto."\",\"";
	$sql.=    $this->Usuario."\",\"";
	$sql.=    $this->Revisado."\",\"";
	$sql.=    $this->FechaCreacion."\");";
  
	$this->ArticuloID = accederMySQL($sql,"ID");
	
	// ahora que tenemos el identificador del artculo
	// generamos su secuencia
	$this->Secuencia = $sSecuencia .trim(fijo($this->ArticuloID));
	$this->modificarArticulo();
  
	$this->_bDirty = False;
  
} // fin aadirArticulo


 
function modificarArticulo() {
 
  
	// Rutina de modificacin de Articulos
	if (!$this->_bDirty) return;
        
	$thiscopia = $this->_Lista;  
	   
	// Si tiene referencias no se modifican las claves
	if ($this->TieneReferencias()) {
	      unset($this->RefArticuloID);
	      unset($this->Secuencia);
	}
      
	$this->UltimaMod = date("Y-m-d H:i:s");
        
	$sql= "UPDATE Articulos SET ";
	foreach ($this->_aLista as $key => $value){  
		if ($key <> "ArticuloID"){    
			$sql =  $sql . " " . $key . " = '". $value . "' ,";
		}
	} 
	$sql = substr($sql,0,strlen($sql)-1)." WHERE ArticuloID = \"".$this->ArticuloID ."\";";
     
	accederMySQL($sql);
	$this->_Lista = $thiscopia;
	$this->_bDirty = False;
	

}  
     
function eliminarArticulo() {


	if ($this->TieneReferencias()) {
		// No se elimina el artculo: otros artculos dependen de l 
		echo LIT19001;
		return;
	}
      
	$sql="DELETE FROM Articulos WHERE ArticuloID = \"".$this->ArticuloID."\";";
	accederMySQL($sql);
 
      
} // fin eliminarArticulo

function tieneReferencias() {
          
 
	// se verifica que ese artculo no tenga otros artculos dependientes
	// es una autoreferencia a la propia tabla
      
	$sql="SELECT Count(*) FROM Articulos 
            WHERE 
            RefArticuloID = \"".$this->ArticuloID."\";";

	// crea el conjunto de resultados
	$rst = accederMySQL($sql);

	$row = $rst->fetch_row();
	$rst->free();
	
	if ($row[0] <> 0) {Return true;} 
	else {return False;}

      
} // fin tieneReferencias


   
} // fin clase Articulo
 
?>

