<?php
// archivo: confirmarcompra.php
// objetivo: datos del cliente
// explicacin captulo 23

// esta pgina es puro proceso de base de datos
// casi no tiene HTML
// Lee el registro de Cliente
// Lee la Cesta
// Lee los ItemCesta (elementos de la cesta)
// Inicia la transaccin
//   Inserta el pedido
//   Inserta los tem del pedido
//   Verifica las existencias del catlogo
// Finaliza la transaccin ( si alguna operacin
// de base de datos da error retrocede la transaccin)
// Informa en la pgina el resultado de toda la operacin

require_once("plantilla.php");
 


// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(true,$aMENUGEN);

//$_SESSION['Cliente'] = 6;
//$_SESSION['Cesta'] = 41;
//$_SESSION['Pedido'] = 57;

////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios limitados
////////////////////////////////////////////////////
conectar(USERNORMAL,PSWUSERNORMAL);

////////////////////////////////////////////////////
// Barra de navegacin del proceso de compra
////////////////////////////////////////////////////
tabNavegaC($aMENU01,LIT00006); 

////////////////////////////////////////////////////
// Si no hay cesta activa vuelve al inicio
////////////////////////////////////////////////////
if (!isset($_SESSION['Cesta']))
	redirect("index.php");

////////////////////////////////////////////////////
// Si no est en sesin debe autenticarse
////////////////////////////////////////////////////
if (!isset($_SESSION['Cliente']))
    redirect("autenticarse.php");

////////////////////////////////////////////////////
// Obtener datos del cliente
////////////////////////////////////////////////////
$oCli = New Cliente;

$aCli = $oCli->leerCliente();


////////////////////////////////////////////////////
// Obtener datos de la cesta
////////////////////////////////////////////////////
$oCesta = New Cesta;

////////////////////////////////////////////////////
// Obtener datos de los totales de la cesta
////////////////////////////////////////////////////
$oCesta->totalizarCesta();


////////////////////////////////////////////////////////
// Inicio de la transaccin
////////////////////////////////////////////////////////
$con->autocommit(FALSE);

////////////////////////////////////////////////////////
// Insercin del pedido
////////////////////////////////////////////////////////
$oPedido = New Pedido(0);
$oPedido->ClienteID			=$aCli["ClienteID"];
$oPedido->FechaPedido		=date("Y-m-d H:i:s");
$oPedido->Nombre			=$aCli["Nombre"];
$oPedido->Apellidos			=$aCli["Apellidos"];
$oPedido->EMail				=$aCli["EMail"];
$oPedido->Direccion			=$aCli["Direccion"];
$oPedido->Ciudad			=$aCli["Ciudad"];
$oPedido->Provincia			=$aCli["Provincia"];
$oPedido->CodigoPostal		=$aCli["CodigoPostal"];
$oPedido->Telefono			=$aCli["Telefono"];
$oPedido->FAX				=$aCli["FAX"];
$oPedido->TipoTarjeta		=$aCli["TipoTarjeta"];
$oPedido->NumeroTarjeta		=$aCli["NumeroTarjeta"];
$oPedido->NombreEntarjeta	=$aCli["NombreEntarjeta"];
$oPedido->FechaCaducidad	=$aCli["FechaCaducidad"];
$oPedido->TipoEnvio			=$oCesta->TipoEnvio;
$oPedido->MedioPago			="Tarjeta";
$oPedido->PesoEnvio			=$oCesta->AcumPeso;
$oPedido->GastosEnvio		=$oCesta->GastosEnvio;
$oPedido->PrecioSinIVA		=$oCesta->AcumPrecio;
$oPedido->IVA				=$oCesta->AcumIVA;
$oPedido->TotalCargo		=$oCesta->TotalCargo;
$oPedido->Estado			=LIT07019;
$oPedido->FechaEstado		=date("Y-m-d H:i:s");

$oPedido->aadirPedido();

$oItemsCesta = New ItemsCesta;
$aB = $oItemsCesta->leerItemsCesta();

$bOK = True;
for($i=0;$i<count($aB) ;$i++) {

 	////////////////////////////////////////////////////////
	// Insercin de los tems del pedidos
	////////////////////////////////////////////////////////
	$oItemPedido = New ItemPedido;
      
	$oItemPedido->PedidoID 		= $oPedido->PedidoID;
	$oItemPedido->LibroID 		= $aB[$i]["LibroID"];
	$oItemPedido->Unidades 		= $aB[$i]["CantidadUnidades"];
	$oItemPedido->PesoTotal 	= $aB[$i]["PesoT"];
	$oItemPedido->PrecioTotal 	= $aB[$i]["PrecioT"];
	$oItemPedido->IVATotal 		= $aB[$i]["IVAT"];
	$oItemPedido->PrecioVP 		= $aB[$i]["PrecioVP"];
	$oItemPedido->aadirItemPedido();
      
	$oLibro = New Libro($oItemPedido->LibroID);
	if ($oLibro->comprobarExistencias($oItemPedido->Unidades) == FALSE) {
 	      ////////////////////////////////////////////////////////
          // saca el mensaje pero sigue el proceso para verificar
          // las existencias de todos los libros solicitados
          ////////////////////////////////////////////////////////
          // No se confirma el pedido  
          echo LIT07014;
          // No hay suficientes existencias del libro  
          echo LIT07015. $oLibro->LibroID."<br>";
          $bOK=False;
	}
}
          

if (!$bOK)  {
	////////////////////////////////////////////////////////////
	// retrocede todas las actualizaciones de la transaccin
	////////////////////////////////////////////////////////////
	$con->rollback();
} 
else  {

 

	////////////////////////////////////////////////////////////
	// confirma las actualizaciones de la transaccin
	///////////////////////////////////////////////////////////
	$con->commit();
	
	////////////////////////////////////////////////////////////////
	//
	// aqu se podra insertar la funcin de proceso de la tarjeta
	// de crdito
	//
	////////////////////////////////////////////////////////////////
	echo "<form action=\"https://www.paypal.com/cgi-bin/webscr\" method='post'>";
	echo "<input type='hidden' name='cmd' value='_xclick'>";
	//echo "<input type='hidden' name='business' value='edgartest@edgartest.com'>";
	echo "<input type='hidden' name='return' value='http://www.editorialcolumbus.com/buena.php'>";
    echo "<input type='hidden' name='cancel_return' value='http://www.editorialcolumbus.com/mala.php'>";
	echo "<input type='hidden' name='business' value='".LIT07016."'>";
	echo "<input type='hidden' name='item_name' value='".LIT07017." #  ".$oPedido->PedidoID."'>";
	echo "<input type='hidden' name='currency_code' value='EUR'>";
	 echo "<input type='hidden' name='amount' value=\"".$oPedido->TotalCargo."\">";
	//echo "<input type='hidden' name='amount' value=\"1\">";
	echo "<input type='image' src=\"http://www.paypal.com/es_ES/i/btn/x-click-but01.gif\" name='submit' alt='".LIT07018."'>";
	echo "</form>";
     
  
	// Hay existencias para suministrar su pedido. 
	// Para realizar la compra pulse el botn Paypal 
	echo "<br><b>".LIT07010."</b><br>";
}

// informacin de pie de pgina
cerrarPagina();

?>