<?php
// archivo: finalizarpedido.php
// explicacin captulo 25

// objetivo: finalizar la compra

// esta pgina es puro proceso de base de datos
// casi no tiene HTML
// Lee el registro de Cliente
// Lee el pedido  
// Inicia la transaccin
//   elimina la cesta
//   modifica el estado del pedido
//   actualiza las existencias del catlogo
// Finaliza la transaccin ( si alguna operacin
// de base de datos da error retrocede la transaccin)
// Enva un email al cliente confirmando la compra
// Enva un email a cada proveedor para pedir la reposicin
// Informa en la pgina el resultado de toda la operacin


require_once("plantilla.php");

// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(true,$aMENUGEN);

$_SESSION['Cliente'] = 6;
$_SESSION['Pedido'] = 20;


////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios limitados
////////////////////////////////////////////////////
conectar(USERNORMAL,PSWUSERNORMAL);

////////////////////////////////////////////////////
// Barra de navegacin del proceso de compra
////////////////////////////////////////////////////
tabNavegaC($aMENU01,LIT00006); 

////////////////////////////////////////////////////
// Si no hay cesta activa vuelve al inicio
////////////////////////////////////////////////////
if (!isset($_SESSION['Pedido']))
	redirect("index.php");

////////////////////////////////////////////////////
// Si no est en sesin debe autenticarse
////////////////////////////////////////////////////
if (!isset($_SESSION['Cliente']))
    redirect("autenticarse.php");

////////////////////////////////////////////////////
// Obtener datos del cliente
////////////////////////////////////////////////////
$oCli = New Cliente;
$aCli = $oCli->leerCliente();


////////////////////////////////////////////////////
// Obtener datos del pedido
////////////////////////////////////////////////////
$oPedido = New Pedido($_SESSION['Pedido']);

if (($oPedido->Estado <> LIT07019)||
	($oPedido->ClienteID <> $_SESSION['Cliente'])) {
	// Situacin incorrecta del pedido
	echo LIT17003;	
}
else {
	////////////////////////////////////////////////////////
	// Inicio de la transaccin
	////////////////////////////////////////////////////////
	$con->autocommit(FALSE);
	
	////////////////////////////////////////////////////////////
	// Borrado de la cesta y del tem de la cesta
	////////////////////////////////////////////////////////////
	$oCesta  = New Cesta;
	$oCesta->eliminarCesta();
	

	////////////////////////////////////////////////////////
	// Actualizacin del pedido
	////////////////////////////////////////////////////////
	// nuevo estado del pedido: pagado en PayPal 
	// (espera de email de comprobacin)
	
	$oPedido->Estado= LIT07023;
	$oPedido->FechaEstado=date("Y-m-d H:i:s");

	$oPedido->modificarPedido();


	
	echo LIT07022 . $oPedido->PedidoID ;
	
	/////////////////////////////////////////////////////////////
	// Email al comprador
	/////////////////////////////////////////////////////////////
	$to = $aCli['EMail'] ."\r\n";
	// direccin de email con signos <...>  
	$subject = LIT07001;
	
	$body = "<html><head><title>".LIT07002." </title></head>";
	$body .= "<body>".LIT07003.$oPedido->PedidoID."<br><br>";
	$body .= LIT07004.DE_EMAIL."</body></html>\r\n";
	
	$header = "MIME-Version: 1.0\r\n";
	$header .= "Content-type: text/html; charset=iso-8859-1\r\n";
	$header .= "To: " . $to ."\r\n";
	$header .= "From:" . DE_EMAIL ."\r\n";
	// From con signos <....> 
	
	mail($to, $subject, $body, $header);

	/////////////////////////////////////////////////////////////
	// Email a los proveedores para la reposicin de los productos
	/////////////////////////////////////////////////////////////
	$bOK = True;
	$oItemsPedido= New ItemsPedido();
	$aItemsPedido=$oItemsPedido->leerItemsPedido($oPedido->PedidoID);

	for($i=0;$i<$oItemsPedido->cantItemsPedido();$i++) {
    
		$oLibro = New Libro($aItemsPedido[$i]["LibroID" ]);
		$oLibro->reducirExistencias($aItemsPedido[$i]["Unidades"]);  

		$to =$aItemsPedido[$i]["EMail" ];
		$subject = LIT07006;
		$body = "<html><head><title>".LIT07002."</title></head>";
		$body .= "<body>".LIT07008.$aItemsPedido[$i]["Unidades"].LIT07007;
		$body .= $aItemsPedido[$i]["LibroID" ]. "<br><br>";
		$body .= LIT07004.DE_EMAIL."</body></html>";
		$header = "MIME-Version: 1.0\n";
		$header .= "Content-type: text/html; charset=iso-8859-1\n";
		$header .= "From:" .DE_EMAIL;

		mail($to, $subject, $body, $header);

	}
	////////////////////////////////////////////////////////////
	// confirma las actualizaciones de la transaccin
	///////////////////////////////////////////////////////////
	$con->commit();
	
	unset($_SESSION['Cesta']); 
	unset($_SESSION['Pedido']);
	echo "<br><b>".LIT07011."</b><br>";
}

// informacin de pie de pgina
cerrarPagina();
?>