<?php
// archivo: compra/revisardatos.php
// objetivo: datos generales y gastos de envo
// explicacin en captulo 22

// esta pantalla tiene tres partes:
// 1) datos del cliente
// 2) datos de la cesta
// 3) eleccin del tipo de envo (con diferentes tarifas)

// Esta pgina lo nico que actualiza es el tipo de envo de la cesta
// el resto slo muestra la informacin y coloca enlaces a diversas partes
// de la aplicacin.
// Desde esta pgina se puede ir a:
// 1) seguir comprando
// 2) cambiar datos personales del cliente
// 3) cambiar datos de la cesta
// 4) cambiar tipo de envo (se hace en esta misma pgina)
// 5) confirmar la compra

////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////
require_once("plantilla.php");


// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(True,$aMENUGEN); 

////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios limitados
////////////////////////////////////////////////////
conectar(USERNORMAL,PSWUSERNORMAL);

////////////////////////////////////////////////////
// Barra de navegacin del proceso de compra
////////////////////////////////////////////////////
tabNavegaC($aMENU01,LIT00003);

//$_SESSION['Cliente'] = 1;
//$_SESSION['Cesta'] = 52;

////////////////////////////////////////////////////
// Si no est en sesin debe autenticarse
////////////////////////////////////////////////////
if (!isset($_SESSION['Cliente']))
    redirect("autenticarse.php");

////////////////////////////////////////////////////
// Si no hay cesta activa vuelve al inicio
////////////////////////////////////////////////////
if (!isset($_SESSION['Cesta']))
 	redirect("index.php");

// comienzo 1ra. parte de la pgina (Datos del cliente)

////////////////////////////////////////////////////
// Obtener datos del cliente de la sesin vigente
////////////////////////////////////////////////////
$oCli = new Cliente;
$aCli= $oCli->leerCliente();


////////////////////////////////////////////////////
// Mostrar todos los datos actuales del cliente
////////////////////////////////////////////////////

// tabla principal de los datos del cliente
echo "<table valign=\"top\" width=\"100%\" border=\"3\">";
echo "<tr>";

// tabla de la izquierda de la pantalla
echo "<td><table valign=\"top\" width=\"100%\" border=\"1\">";
echo "<tr><td  valign=\"top\">Nombre:</td><td><b>".clean($aCli['Nombre'])."</b></td></tr>";
echo "<tr><td>".LIT03001.": </td><td><b>".clean($aCli['Apellidos'])."</b></td></tr>";
echo "<tr><td>".LIT03002.": </td><td>".clean($aCli['EMail'])."</td></tr>";
echo "<tr><td>".LIT03004.": </td><td>".clean($aCli['Direccion'])."</td></tr>";
echo "<tr><td>".LIT03005.": </td><td>".clean($aCli['Ciudad'])."</td></tr>";
echo "<tr><td>".LIT03006.": </td><td>".clean($aCli['Provincia'])."</td></tr>";
echo "<tr><td>".LIT03007.": </td><td>".clean($aCli['CodigoPostal'])."</td></tr>";
// fin tabla de la izquierda
echo "</table></td>";

// tabla de la derecha de la pantalla
echo "<td><table valign=\"top\" width=\"100%\" border=\"1\">";
echo "<tr><td>".LIT03008.": </td><td>".clean($aCli['Telefono'])."</td></tr>";
echo "<tr><td>".LIT03009.":</td><td>".clean($aCli['FAX'])."</td></tr>";
echo "<tr><td>".LIT03010.":</td><td>";
echo $aCli['TipoTarjeta']."</td></tr>";

// Paypal no requiere datos de tarjetas de crdito
if ($aCli['TipoTarjeta'] <> "PAYPAL"){ 
	echo "<tr><td>".LIT03011.": </td><td>".clean($aCli['NumeroTarjeta'])."</td></tr>";
	echo "<tr><td>".LIT03012.": </td><td>".clean($aCli['NombreEntarjeta'])."</td></tr>";
	echo "<tr><td>".LIT03013.": </td><td>".clean($aCli['FechaCaducidad'])."</td></tr>";
}

echo "<tr><td>".LIT03014.": </td><td>".$aCli['AceptaCookies']."</td></tr>";
echo "<tr><td>".LIT03015.": </td><td>".$aCli['Suscriptor']."</td></tr>";
// fin de la tabla de la derecha
echo "</table></td></tr>";

// fin de la tabla principal
echo "</table>";

// fin 1ra. parte de la pgina

// comienzo 2da. parte de la pgina (Cesta)
//////////////////////////////////////////////////////////
// Listado del contenido de la cesta
//////////////////////////////////////////////////////////
$oCesta = new Cesta;

 ////////////////////////////////////////////////////
// Rutina de actualizacin del tipo de envo
////////////////////////////////////////////////////


if ($_POST["Envo"]=="Cambiar"){
  $oCesta->TipoEnvio =$_POST['BTarifa'];
  $oCesta->modificarCesta();
}
$aItems=$oCesta->leerItemsCesta();
 
echo "<h3><center>Datos de la cesta</center></h3>";
// Para esta tabla simple utilizaremos nuestro objeto TablaHTML

// Crea un objeto TablaHTML
$oTab2 = new  TablaHTML("Comercio");

// Coloca los ttulos de las columnas
$oTab2->asignar_titulos_columnas(
            LIT02007, LIT02002, LIT02005,
            LIT03016, LIT03017, LIT03018,
            LIT03020);

// Formularios para items de cesta
$i=0;
$iacumPrecio=0;
$iacumPeso=0;
while ($i < $oCesta->cantItemsCesta())  {
  unset($aB);
  $aB[] = $i+1;

  $aB[] = clean($aItems[$i]['LibroID']);
  $aB[] = clean($aItems[$i]['Nombre']);
  $aB[] = clean($aItems[$i]['Autor']);
  $aB[] = $aItems[$i]['Precio']+$aItems[$i]['IVA'];
  $aB[] = $aItems[$i]['CantidadUnidades'];
  $isumPrecio =  ($aItems[$i]['Precio']+$aItems[$i]['IVA'])*$aItems[$i]['CantidadUnidades'];
  $aB[] = $isumPrecio;
  $isumPeso = $aItems[$i]['Peso']*$aItems[$i]['CantidadUnidades'];
  $aB[] = $isumPeso;
  $iacumPrecio = $iacumPrecio + $isumPrecio;
  $iacumPeso = $iacumPeso + $isumPeso;
  $oTab2->aadir_fila($aB);
  $i++;

}

echo $oTab2->retornoHTML();

// fin 2da parte de la pgina

// comienzo 3ra. parte de la pgina (Tipo de envo)
//////////////////////////////////////////////////////////
// Eleccin del tipo de envo
//////////////////////////////////////////////////////////
echo "<h3><center>".LIT03027."</center></h3>";

// Crea un objeto TablaHTML
$oTab2 = new  TablaHTML("Comercio");

// Coloca los ttulos de las columnas
$oTab2->asignar_titulos_columnas(
              LIT03021, LIT03020,LIT03023,
              LIT03018, LIT03022, "",
              LIT03024);


// funcin tarifaEnvio calcula el gasto de envo en base al peso
// esto podra tomar en cuenta tambin si es un envo local
// o interprovincial, simple o urgente, etc.

$iGastosEnvio=tarifaEnvio($iacumPeso,$oCesta->TipoEnvio);

// limpiar la matriz $aB
unset($aB);
$aB[]="<form method=\"POST\" action=\"".SELF."\" enctype=\"multipart/form-data\">1";
$aB[1]=$iacumPrecio;
$aB[2]=$iacumPeso;
$aB[3]=$iGastosEnvio;
$aB[4]=$iacumPrecio+$iGastosEnvio;
$aB[5]="<select name='BTarifa'>";
$i=0;
while ($i < count($aTARIFAS)) {
		$sel="";
		if ($oCesta->TipoEnvio == $aTARIFAS[$i])  $sel = "selected='selected'";
		$aB[5] .= "<option value='".$aTARIFAS[$i]."'". $sel.">".$aTARIFAS[$i]."</option>";
		$i++;
} 
$aB[5] .= "</select>";
$aB[6]="<input type=\"submit\" name=\"Envo\" value=\"Cambiar\"></form>";
$oTab2->aadir_fila($aB);

echo $oTab2->retornoHTML();

// informacin de pie de pgina
cerrarPagina();

?>
