<?php
// archivo: mantarticulos.php
// explicacin captulo 27

// Este archivo: /admin/mantarticulos.php

////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////
require_once("plantilla.php");

// Esta pgina permite realizar el mantenimiento de los artculos
// por lo que slo la utiliza el administrador (autenticado)
// Desde esta pgina se pueden realizar altas, bajas y modificaciones
// en los artculos
// Tambin se incluye un buscador para limitar la lista de articulos
// visualizados


if ($_SESSION['Autenticado']!=1 ) {       
	redirect("admin.php");
}
 
// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(true,$aMENUADM);


$_POST ['vArticuloID'] = 1;
$_POST ['vTemaID'] = 3;
$_POST ['vUsuario'] = "Jos D\'Andy";
$_POST ['vRevisado'] = 1;
$_POST ['vRefArticuloID'] = 0;
$_POST ['vTexto'] = "texto del 2do lo borrar ";
$_POST ['Op'] = "Modificar"; 
 

////////////////////////////////////////////////////
// enlaces a otras pginas
////////////////////////////////////////////////////
// Tabla de navegacin del administrador del sitio

tabnavegaA($aMENU03,LIT14001,LIT00011);

////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios de administrador
////////////////////////////////////////////////////
conectar(USERADMIN,PSWUSERADMIN);

////////////////////////////////////////////////////
// Crea un objeto artculo
////////////////////////////////////////////////////
$oArt = new Articulo();

// Rutina de insercin de un nuevo articulo  

if (($_POST["Op"]=="Aadir")) {
	$oArt->TemaID = $_POST["iTemaID"];
	$oArt->RefArticuloID = $_POST["iRefArticuloID"];
	$oArt->Texto = $_POST["iTexto"];
	$oArt->Revisado = "1";
	$oArt->Usuario = $_POST["iUsuario"];
	$oArt->aadirArticulo();
}

// Rutina de modificacin de un articulo  

elseif ($_POST["Op"]=="Modificar") {
	$oArt->ArticuloID = $_POST["vArticuloID"];
	$oArt->TemaID = $_POST["vTemaID"];
	$oArt->RefArticuloID = $_POST["vRefArticuloID"];
	$oArt->Texto = $_POST["vTexto"];
	$oArt->Revisado = $_POST["vRevisado"];
	$oArt->Usuario = $_POST["vUsuario"];
	$oArt->modificarArticulo();
}

// Rutina de eliminacin de un articulo  

elseif ($_POST["Op"]=="Eliminar") {
	$oArt->ArticuloID = $_POST["vArticuloID"];
	$oArt->eliminarArticulo();
}

////////////////////////////////////////////////////
// Rutina de filtrado de articulos
////////////////////////////////////////////////////

elseif ($_POST["Op"]=="Buscar") {
	$aFiltro = array();
	if (trim($_POST['BTitulo']) <>"") $aFiltro[]=" A.Titulo Like '%".trim($_POST['BTitulo'])."%' ";
	if (trim($_POST['BTexto']) <>"") $aFiltro[]=" A.Texto Like '%".trim($_POST['BTexto'])."%' ";
	if (trim($_POST['BUsuario']) <>"") $aFiltro[]=" A.Usuario Like '%".trim($_POST['BUsuario'])."%' ";
	if (trim($_POST['BTema']) <>"") $aFiltro[]=" T.Nombre Like '%".trim($_POST['BTema'])."%' ";
	if (trim($_POST['BFecha']) <>"") $aFiltro[]=" A.FechaCreacion >= DATE('".trim($_POST['BFecha'])."') ";
  
	// para seleccionar los artculos pendientes de revisin
	// sta es una opcin exclusiva del administrador del foro
	// los usuarios del foro slo visualizan los artculos revisados
	if (isset($_POST['BRevisado']) ) $aFiltro[]=" A.Revisado = 0 ";
 
  
	if (count($aFiltro)> 0 ) $sFiltro = " WHERE ".$aFiltro[0]. " ";
   $i = 1;
	while ($i < count($aFiltro)) {
		$sFiltro .= " OR " . $aFiltro[$i] ;
		$i++;
	}
}

////////////////////////////////////////////////////
// Rutina de filtrado de articulos por referencia
////////////////////////////////////////////////////
elseif ($_GET["VerArt"]=="Buscar") {
	$sFiltro=" WHERE  RefArticuloID = ".trim($_GET['vRefArticuloID'])." ";
	$texto= " artculos que hacen referencia a ".trim($_GET['vRefArticuloID']);
}

////////////////////////////////////////////////////
// Rutina de filtrado de articulos desde una referencia
////////////////////////////////////////////////////
elseif ($_POST["Op"]=="BuscarRef") {
	
	$sFiltro=" WHERE ArticuloID = ".trim($_POST['vRefArticuloID'])." ";
  
	$texto= " artculo referencia ".trim($_POST['vRefArticuloID']);
}

////////////////////////////////////////////////////
// Rutina de filtrado de articulos por tema
////////////////////////////////////////////////////
elseif ($_GET["VerTema"]=="Buscar") {
	$sFiltro=" WHERE  T.TemaID = ".trim($_GET['vTemaID'])." ";
  
	$texto= " artculos del tema ".trim($_GET['vTemaID']);
}

////////////////////////////////////////////////////
// Rutina de filtrado general de tabla
////////////////////////////////////////////////////
elseif ($_POST["Op"]=="BuscarTabla") {
	$aFiltro = array();
    $aFiltro[]=" A.Titulo Like '%".trim($_POST['BTexto'])."%' ";
    $aFiltro[]=" A.Texto Like '%".trim($_POST['BTexto'])."%' ";
    $aFiltro[]=" A.Usuario Like '%".trim($_POST['BTexto'])."%' ";
    $aFiltro[]=" T.Nombre Like '%".trim($_POST['BTexto'])."%' ";
  
  
    $sFiltro = " WHERE ".$aFiltro[0]. " ";
    $i = 1;
    while ($i < count($aFiltro)) {
		$sFiltro .= " OR " . $aFiltro[$i] ;
		$i++;
    }
}
////////////////////////////////////////////////////
// Obtener los articulos  
////////////////////////////////////////////////////
$oArts= New Articulos();
$aArts = $oArts->leerArticulos($sFiltro);


////////////////////////////////////////////////////
// Obtener la lista de temas vigentes
////////////////////////////////////////////////////
$oTemas = New Temas();
$aTemas = $oTemas->leerTemas("");

if (isset($texto) ) echo $texto."<BR>";

echo LIT14002 . $oArts->cantArticulos().")<BR>";

echo "<a href='#aadir'>".LIT14003."</a>";

// //////////////////////////////////////////////////
// Mostrar todos los articulos seleccionados
// //////////////////////////////////////////////////
$i = 0;

// Genera la tabla para bsquedas 
tabBuscarForo($oArts->cantArticulos()); 

// genera el formulario de los artculos seleccionados
while ($i < $oArts->cantArticulos()) {
  
	echo "<form name='form14".$i."' method='POST' action='".SELF."' enctype='multipart/form-data'>";
	echo "<table valign='top' width='600' border='1'>";
	echo "<tr>";  
	echo "<td><table valign='top' width='150' border='0'>";
	echo "<tr><td>".LIT14006." ".$aArts[$i]['ArticuloID']."<input type='hidden' name='vArticuloID' value=\"".clean($aArts[$i]['ArticuloID'])."\"></td>";
	$checked="";
	if (clean($aArts[$i]['Revisado']<>'0')) $checked= "checked";
	echo "<td>".LIT14010."<input type='checkbox' name='vRevisado' value='1' " . $checked . "></td></tr>";
	// Select de temas
	echo "<tr><td>".LIT14008."<BR><select name='vTemaID'>";
	reset($aTemas);
	foreach ($aTemas as $temp) {
		$sel="";
		if ($temp['TemaID']==$aArts[$i]['TemaID']) $sel = "selected='selected'";
		echo "<option value='".$temp['TemaID']."'" .$sel.">".$temp['Nombre']."</option>";
	}
	echo "</select></td></tr>";

	echo "<tr><td>".LIT14005."<BR><b><input type='text' size='15' name='vUsuario' value=\"".clean($aArts[$i]['Usuario'])."\"></b></td></tr>";
	echo "<tr><td>".LIT14007."<BR><input type='text' name='vRefArticuloID' value=\"".$aArts[$i]['RefArticuloID']."\" size='5'></td>";
	echo "<td><input type='image' src=\"".PATHGIF."buscar.jpg\" TITLE=\"".LIT00010."\"  width='20' height='20' 
		value='BuscarRef' TITLE='".LIT00007."'   onClick='document.form14".$i.".Op.value=\"BuscarRef\";' ></td></tr>\n";
	echo "<tr><td>".LIT14009."<BR><b>".clean($aArts[$i]['FechaCreacion'])."</b></td></tr>";
	echo "</table></td>";
	echo "<td><table valign='top' width='450' border='1'>";
	echo "<tr><td>".LIT14004."<textarea  cols='50' rows='10' name='vTexto'>".clean($aArts[$i]['Texto'])."</textarea></td></tr>";
	echo "</table></td></tr>";
	echo "</table>";
  
	// Botones submit
	echo "<input type='image' src ='".PATHGIF."eliminar.gif'  width=35 height=35  
		value='Eliminar' TITLE='".LIT00007."'   onClick='document.form14".$i.".Op.value=\"Eliminar\";' >\n";
	echo "<input type='image' src ='".PATHGIF."modificar.gif'  width=35 height=35 
		value='Modificar' TITLE='".LIT00008."' onClick='document.form14".$i.".Op.value=\"Modificar\";' >\n";
	echo "<input type='hidden' name='Op' value=' '>\n";
	echo "</form>";
	$i++;
 }
 

////////////////////////////////////////////////////
// Formulario de insercin de nuevos articulos
////////////////////////////////////////////////////
echo "<a name='aadir'></a>";
echo "<form name='form15' method='POST' action='".SELF."' enctype='multipart/form-data'>";
echo "<table valign='top' width='600' border='3'>";
echo "<tr>";

echo "<td><table valign='top' width='150' border='0'>";

// Select de temas
echo "<tr><td>".LIT14008."<br><select name='iTemaID'>";
reset($aTemas);
foreach ($aTemas as $temp) 
        echo "<option value='".$temp['TemaID']."'" .$sel.">".$temp['Nombre']."</option>";
echo "</select></td></tr>";
echo "<tr><td>".LIT14005."<BR><b><input type='text' size='15' name='iUsuario' value=''></b></td></tr>";
// Select de referencia a artculo
echo "<tr><td>".LIT14007."<br><select name='iRefArticuloID'>";
reset($aArts);
foreach ($aArts as $temp) 
        echo "<option size ='5' value='".$temp['RefArticuloID']."'" .$sel.">".$temp['RefArticuloID']." </option>";
echo "</select></td></tr>";

echo "</table></td>";
echo "<td><table valign='top' width='450' border='1'>";
echo "<tr><td>".LIT14004."<textarea  cols='50' rows='10' name='iTexto'></textarea></td></tr>";
echo "</table></td></tr>";
echo "</table>";
echo "<input type='image' src ='".PATHGIF."insertar.gif'  
  value='Aadir' TITLE='".LIT00009."' width=35 height=35 onClick='document.form15.Op.value=\"Aadir\";' >\n";
echo "<input type='hidden' name='Op' value=' '>\n";
echo "</form>";

// informacin de pie de pgina
cerrarPagina();
?>

 