<?php
// archivo: mantlibros.php
// Este archivo: /admin/mantlibros.php
// explicacin captulo 17

////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////
require_once("plantilla.php");

// Esta pgina permite realizar el mantenimiento del catlogo
// por lo que slo la utiliza el administrador (autenticado)
// Desde esta pgina se pueden realizar altas, bajas y modificaciones
// del catlogo
// Tambin se incluye un buscador para limitar la lista de libros
// visualizados


if ($_SESSION['Autenticado']!=1 ) {       
      redirect("admin.php");
}
 
// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(true,$aMENUADM);

////////////////////////////////////////////////////
// enlaces a otras pginas
////////////////////////////////////////////////////
// Tabla de navegacin del administrador del sitio
tabnavegaA($aMENU02,LIT10001,LIT00011);

////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios de administrador
////////////////////////////////////////////////////
conectar(USERADMIN,PSWUSERADMIN);
//$_POST["Op"]= "BuscarTabla";
//$_POST["BTexto"] = "PHP";
//$_POST["Autor"]="JUAN";
////////////////////////////////////////////////////
// Rutinas de operaciones de actualizacin de una fila
////////////////////////////////////////////////////
$oLib = new Libro();
$sFiltro="";

// Rutina de insercin de un nuevo libro en el catlogo

if (($_POST["Op"]=="Aadir")&&($_POST["iLibroID"]!=" ")) {
  
     $oLib->LibroID = $_POST["iLibroID"];
     $oLib->DepartamentoID = $_POST["iDepartamentoID"];
     $oLib->Nombre = $_POST["iNombre"];
     $oLib->DetalleMenor = $_POST["iDetalleMenor"];
     $oLib->DetalleMayor = $_POST["iDetalleMayor"];
     $oLib->Autor = $_POST["iAutor"];
     $oLib->Editorial = $_POST["iEditorial"];
     $oLib->Paginas = $_POST["iPaginas"];
     $oLib->Cubierta = $_POST["iCubierta"];
     $oLib->Tema = $_POST["iTema"];
     $oLib->Imagen = $_POST["iImagen"];
     $oLib->Peso = $_POST["iPeso"];
     $oLib->Precio = $_POST["iPrecio"];
     $oLib->IVA = $_POST["iIVA"];
     $oLib->Existencias = $_POST["iExistencias"];
     $oLib->ProveedorID = $_POST["iProveedorID"];
     $oLib->Cubierta = $_POST["iCubierta"];
     $oLib->aadirLibro();
}

// Rutina de modificacin de un libro del catlogo

elseif ($_POST["Op"]=="Modificar") {
     $oLib->LibroID = $_POST["vLibroID"];
     $oLib->DepartamentoID = $_POST["vDepartamentoID"];
     $oLib->Nombre = $_POST["vNombre"];
     $oLib->DetalleMenor = $_POST["vDetalleMenor"];
     $oLib->DetalleMayor = $_POST["vDetalleMayor"];
     $oLib->Autor = $_POST["vAutor"];
     $oLib->Editorial = $_POST["vEditorial"];
     $oLib->Paginas = $_POST["vPaginas"];
     $oLib->Cubierta = $_POST["vCubierta"];
     $oLib->Tema = $_POST["vTema"];
     $oLib->Imagen = $_POST["vImagen"];
     $oLib->Peso = $_POST["vPeso"];
     $oLib->Precio = $_POST["vPrecio"];
     $oLib->IVA = $_POST["vIVA"];
     $oLib->Existencias = $_POST["vExistencias"];
     $oLib->ProveedorID = $_POST["vProveedorID"];
     $oLib->Cubierta = $_POST["vCubierta"];
     $oLib->modificarLibro();

}

// Rutina de eliminacin de un libro del catlogo

elseif ($_POST["Op"]=="Eliminar") {
  $oLib->LibroID = $_POST["vLibroID"];
  $oLib->eliminarLibro();
  
}

////////////////////////////////////////////////////
// Rutina de filtrado de libros
////////////////////////////////////////////////////
elseif ($_POST["Op"]=="BuscarTabla") {
  $sFiltro=" WHERE LibroID Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      L.Nombre Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      DetalleMenor Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      DetalleMayor Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      Autor Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      Editorial Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      Tema Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      L.Imagen Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      L.DepartamentoID Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="      L.ProveedorID Like '%".trim($_POST['BTexto'])."%'";
 
  $texto= " donde aparece el texto ".trim($_POST['BTexto']);
}

////////////////////////////////////////////////////
// Rutina de filtrado de libros por proveedor
////////////////////////////////////////////////////
elseif ($_GET["VerProv"]=="Buscar") {
  $sFiltro=" WHERE  ProveedorID = ".trim($_GET['vProveedorID'])." ";
  $texto= " del proveedor ".trim($_GET['vProveedorID']);
}

////////////////////////////////////////////////////
// Rutina de filtrado de libros por departamento
////////////////////////////////////////////////////
elseif ($_GET["VerDepto"]=="Buscar") {
  $sFiltro=" WHERE  D.DepartamentoID = ".trim($_GET['vDepartamentoID'])." ";
  $texto= " del departamento ".trim($_GET['vDepartamentoID']);
}

////////////////////////////////////////////////////
// Obtener los libros del catlogo
////////////////////////////////////////////////////
$oCat= New Catalogo();
$aCat = $oCat->leerProductos($sFiltro);

////////////////////////////////////////////////////
// Obtener la lista de departamentos vigentes
////////////////////////////////////////////////////
$oDeptos = New Departamentos();
$aDeptos = $oDeptos->leerDepartamentos("");


////////////////////////////////////////////////////
// Obtener la lista de proveedores vigentes
////////////////////////////////////////////////////
$oProvs = New Proveedores();
$aProvs = $oProvs->leerProveedores("");


////////////////////////////////////////////////////
// enlaces a otras pginas
////////////////////////////////////////////////////


echo LIT10006 . $oCat->cantProductos() .")<BR>";
echo "<a href='#aadir'>".LIT10007."</a>";

////////////////////////////////////////////////////
// Obtiene las imgenes disponibles en la carpeta images
////////////////////////////////////////////////////
$var = opendir(BASE_DIR.PATHIMG);
while ($file = readdir($var))   $imags[]= $file;
 
////////////////////////////////////////////////////
// Matriz con los tipos de cubiertas
////////////////////////////////////////////////////
Global $aTIPOS01;

// //////////////////////////////////////////////////
// Mostrar todos los libros seleccionados
// //////////////////////////////////////////////////
$i = 0;

while ($i < $oCat->cantProductos()) {
  
  echo "<form name='form10".$i."' method='POST' action='".SELF."' enctype='multipart/form-data'>";
  echo "<table valign='top' width='100%' border='1'>";
  echo "<tr>";
  echo "<td><table valign='top' width='5%' border='1'>";
  echo "<tr><td  valign='top'>".LIT10008."<b><textarea  cols='30' rows='4'  name='vNombre'>".clean($aCat[$i]['Nombre'])."</textarea></b></td></tr>";
  echo "<tr><td align='center'><img  src='" . PATHIMG ."/". clean($aCat[$i]['Imagen']) ."' width='50' height='85' alt='imagen de la portada del libro'/></td></tr>";

  echo "<tr><td>".LIT10009."<select name='vImagen'>";

  foreach($imags as $v) {
     $sel="";
     if ($v==$aCat[$i]['Imagen']) $sel = "selected='selected'";
     echo "<option value='".$v."'" .$sel.">".$v."</option>";
  }

  echo "</select></td></tr>";
  echo "</table></td>";
  echo "<td><table valign='top' width='20%' border='0'>";
  echo "<tr><td>".LIT10010."<br><b><input type='text' name='vAutor' value=\"".clean($aCat[$i]['Autor'])."\"></b></td></tr>";
  echo "<tr><td>".LIT10011."<br><input type='text' name='vEditorial' value=\"".clean($aCat[$i]['Editorial'])."\"></td></tr>";
  echo "<tr><td>".LIT10012."<br>".$aCat[$i]['LibroID']."<input type='hidden' name='vLibroID' value=\"".clean($aCat[$i]['LibroID'])."\"></td></tr>";
  echo "<tr><td>".LIT10013."<br><input type='text' name='vPaginas' value=\"".clean($aCat[$i]['Paginas'])."\"></td></tr>";

  echo "<tr><td>".LIT10014."<br><select name='vCubierta'>";
  reset($aTIPOS01);
  while($temp = each($aTIPOS01)) {
      $sel="";
      if ($temp[1]==$aCat[$i]['Cubierta']) $sel = "selected='selected'";
       echo "<option value='".$temp[0]."'" .$sel.">".$temp[1]."</option>";
  }

  echo "</select></td></tr>";
  echo "<tr><td>".LIT10015."<br><input type='text' name='vPeso' value='".$aCat[$i]['Peso']."'></td></tr>";
  echo "<tr><td>".LIT10016."<br><input type='text' name='vPrecio' value='".$aCat[$i]['Precio']."'></td></tr>";
  echo "<tr><td>".LIT10017."<br><input type='text' name='vIVA' value='".$aCat[$i]['IVA']."'></td></tr>";

  // Select de proveedores
  echo "<tr><td>".LIT10018."<br><select name='vProveedorID'>";
  reset($aProvs);
  foreach ($aProvs as $temp) {
      $sel="";
      if ($temp['ProveedorID']==$aCat[$i]['ProveedorID']) $sel = "selected='selected'";
      echo "<option value='".$temp['ProveedorID']."'" .$sel.">".$temp['Empresa']."</option>";
  }
  echo "</select></td></tr>";

  echo "<tr><td>".LIT10019."<br><input type='text' name='vExistencias' value='".$aCat[$i]['Existencias']."'></td></tr>";
  echo "</table></td>";
  echo "<td><table valign='top' width='60%' border='1'>";

  // Select de departamentos
  echo "<tr><td>".LIT10020."<select name='vDepartamentoID'>";
  reset($aDeptos);
  foreach ($aDeptos as $temp) {
         $sel="";
         if ($temp['DepartamentoID']==$aCat[$i]['DepartamentoID']) $sel = "selected='selected'";
         echo "<option value='".$temp['DepartamentoID']."'" .$sel.">".$temp['Nombre']."</option>";
  }
  echo "</select></td></tr>";

  echo "<tr><td>".LIT10021."<input type='text' name='vTema' value=\"".clean($aCat[$i]['Tema'])."\"></td></tr>";
  echo "<tr><td>".LIT10022."<textarea  cols='50' rows='5' name='vDetalleMenor'>".clean($aCat[$i]['DetalleMenor'])."</textarea></td></tr>";
  echo "<tr><td>".LIT10023."<textarea  cols='50' rows='15' name='vDetalleMayor'>".clean($aCat[$i]['DetalleMayor'])."</textarea></td></tr>";
  echo "</table></td></tr>";
  echo "</table>";

  // Botones submit
  echo "<input type='image' src ='".PATHGIF."eliminar.gif'  width=35 height=35  
  value='Eliminar' TITLE='".LIT00007."'   onClick='document.form10".$i.".Op.value=\"Eliminar\";' >\n";
  echo "<input type='image' src ='".PATHGIF."modificar.gif'  width=35 height=35 
  value='Modificar' TITLE='".LIT00008."' onClick='document.form10".$i.".Op.value=\"Modificar\";' >\n";
  echo "<input type='hidden' name='Op' value=' '>\n";
  echo "</form>";
 $i++;
}
 

////////////////////////////////////////////////////
// Formulario de insercin de nuevos libros
////////////////////////////////////////////////////
echo "<a name='aadir'></a>";
echo "<form name='form10' method='POST' action='".SELF."' enctype='multipart/form-data'>";
echo "<table valign='top' width='640' border='3'>";
echo "<tr>";
echo "<td><table valign='top' width='100' border='1'>";
echo "<tr><td  valign='top'>".LIT10008."<b><textarea  cols='30' rows='4'  name='iNombre'></textarea></b></td></tr>";

// Select de imgenes
echo "<tr><td>".LIT10009."<select name='iImagen'>";
foreach($imags as $v)
        echo "<option value='".$v."'>".$v."</option>";
echo "</select></td></tr>";

echo "</table></td>";
echo "<td><table valign='top' width='200' border='0'>";
echo "<tr><td>".LIT10010."<br><b><input type='text' name='iAutor' value=''></b></td></tr>";
echo "<tr><td>".LIT10011."<br><input type='text' name='iEditorial' value=''></td></tr>";
echo "<tr><td>".LIT10012."<br><input type='text' name='iLibroID' value=''></td></tr>";
echo "<tr><td>".LIT10013."<br><input type='text' name='iPaginas' value=''></td></tr>";

// Select de tipo de cubierta
echo "<tr><td>".LIT10014."<br><select name='iCubierta'>";
reset($aTIPOS01);
while($temp = each($aTIPOS01))
        echo "<option value='".$temp[0]."'>".$temp[1]."</option>";
echo "</select></td></tr>";

echo "<tr><td>".LIT10015."<br><input type='text' name='iPeso' value=''></td></tr>";
echo "<tr><td>".LIT10016."<br><input type='text' name='iPrecio' value=''></td></tr>";
echo "<tr><td>".LIT10017."<br><input type='text' name='iIVA' value=''></td></tr>";

// Select de proveedores
echo "<tr><td>".LIT10018."<br><select name='iProveedorID'>";
reset($aProvs);
foreach ($aProvs as $temp) 
        echo "<option value='".$temp['ProveedorID']."'" .$sel.">".$temp['Empresa']."</option>";
echo "</select></td></tr>";

echo "<tr><td>".LIT10019."<br><input type='text' name='iExistencias' value=''></td></tr>";
echo "</table></td>";
echo "<td><table valign='top' width='340' border='1'>";

// Select de departamentos
echo "<tr><td>".LIT10020."<select name='iDepartamentoID'>";
reset($aDeptos);
foreach ($aDeptos as $temp) 
        echo "<option value='".$temp['DepartamentoID']."'" .$sel.">".$temp['Nombre']."</option>";
echo "</select></td></tr>";

echo "<tr><td>".LIT10021."<input type='text' name='iTema' value=''></td></tr>";
echo "<tr><td>".LIT10022."<textarea  cols='50' rows='5' name='iDetalleMenor'></textarea></td></tr>";
echo "<tr><td>".LIT10023."<textarea  cols='50' rows='15' name='iDetalleMayor'></textarea></td></tr>";
echo "</table></td></tr>";
echo "</table>";
echo "<input type='image' src ='".PATHGIF."insertar.gif'  
  value='Aadir' TITLE='".LIT00009."' width=35 height=35 onClick='document.form10.Op.value=\"Aadir\";' >\n";
echo "<input type='hidden' name='Op' value=' '>\n";
echo "</form>";

// informacin de pie de pgina
cerrarPagina();
?>

 